package com.iderzheng;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningTaskInfo;
import android.content.Context;
import android.content.Intent;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

import java.util.List;


public abstract class SuperActivity extends Activity {
    public static final String TAG = "IDER";
    public static int Count = 1;

    public int id;

    private TextView textView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        id = Count;

        log(new String(new char[21]).replace("\0", "="));
        ActivityManager am = (ActivityManager)getSystemService(Context.ACTIVITY_SERVICE);
        List<RunningTaskInfo> runningTaskInfoList =  am.getRunningTasks(10);
        for (RunningTaskInfo runningTaskInfo : runningTaskInfoList) {
            log(new String(new char[21]).replace("\0", "-"));
            log("id: " + runningTaskInfo.id);
            log("description: " + runningTaskInfo.description);
            log("number of activities: " + runningTaskInfo.numActivities);
            log("topActivity: " + runningTaskInfo.topActivity);
            log("baseActivity: " + runningTaskInfo.baseActivity.toString());
        }

        textView = (TextView) findViewById(R.id.main_text);
        textView.setText(""+ Count++);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        Class<?> cls = null;
        switch (id) {
            case R.id.action_standard:
                cls = StandardActivity.class;
                break;
            case R.id.action_single_top:
                cls = SingleTopActivity.class;
                break;
            case R.id.action_single_task:
                cls = SingleTaskActivity.class;
                break;
            case R.id.action_single_instance:
                cls = SingleInstanceActivity.class;
                break;
        }
        if (cls != null) {
            startActivity(new Intent(this, cls));
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        CharSequence chars = textView.getText();
        if (chars != null && chars.length() > 0) {
            chars = chars + ",";
        }
        chars = chars + String.valueOf(Count++);
        textView.setText(chars);
    }


    @Override
    public String toString() {
        return (getPackageName()+"/" + ((Object)this).getClass() + "   " + id);
    }

    private void log(String log) {
        Log.d(TAG, log);
    }
}
